package org.gcube.portlets.user.td.csvimportwidget.client;

import org.gcube.portlets.user.td.csvimportwidget.client.general.WizardWindow;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVImportSession;

import com.allen_sauer.gwt.log.client.Log;
import com.google.gwt.user.client.Command;


/**
 * 
 */
public class CSVImportWizardTD  extends WizardWindow  {

	protected CSVImportSession importSession;
	private CSVImportWizardTD wizard;
	
	/**
	 * The id of the {@link CSVTarget} to use.
	 * @param targetId
	 */
	
	public CSVImportWizardTD(String title)	{
		super(title);
		setWidth(550);
		setHeight(520);
		
		importSession= new CSVImportSession();
		this.wizard=this;
		
		SourceSelectionCard sourceSelection= new SourceSelectionCard(importSession);
		addCard(sourceSelection);
	
		
		
		Command sayNextCard = new Command() {
			public void execute() {
				try {
					String sourceId = importSession.getSource().getId();
					if (sourceId == null || sourceId.isEmpty()) {
						Log.error("CSV Import Source Id: " + sourceId);
						wizard.showErrorAndHide("CSV Import Source Id is"+sourceId,"Error in source selection", "Error in source Selection",new Throwable("CSV Import Source Id is"+sourceId));
					} else {
						if (sourceId.compareTo("File") == 0) {
							  CSVUploadFileCard csvUploadFileCard = new CSVUploadFileCard(importSession);
							  wizard.addCard(csvUploadFileCard); 
							  Log.info("NextCard CSVUploadFileCard");
							  wizard.nextCard();
						} else {
							if (sourceId.compareTo("Workspace") == 0) {

							} else {

							}
						}
					}
				} catch (Exception e) {
					Log.error("sayNextCard :" + e.getLocalizedMessage());
					wizard.showErrorAndHide("CSV Import error creating next card","CSV Import error creating next card", "CSV Import error creating next card",e);
				}
			}
		};

		this.setNextButtonCommand(sayNextCard);
		
		
		
	}
	
	
	
	
}