/**
 * 
 */
package org.gcube.portlets.user.td.csvimportwidget.client.progress;




import org.gcube.portlets.user.td.gwtservice.shared.TRId;

import com.allen_sauer.gwt.log.client.Log;
import com.sencha.gxt.widget.core.client.ProgressBar;

/**
 * Updates a {@link ProgressBar} progress and text based on {@link CSVImportProgressListener} events.
 * 
 * @author "Giancarlo Panichi" 
 * <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 */
public class CSVImportProgressBarUpdater implements CSVImportProgressListener {
	
	protected ProgressBar progressBar;
	//protected FramedPanel operationResult;
	//protected WizardWindow wizardWindow;
	/**
	 * Creates a new {@link ProgressBar} updater.
	 * @param progressBar the {@link ProgressBar} to update.
	 */
	public CSVImportProgressBarUpdater(ProgressBar progressBar) {
		this.progressBar = progressBar;
	}

	
	/**
	 * {@inheritDoc}
	 */
	@Override
	public void operationComplete(TRId trId) {
		Log.info("Import completed");
		progressBar.updateProgress(1, "Import completed.");	
		
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void operationFailed(Throwable caught, String reason, String failureDetails) {
		Log.info("Import failed");
		progressBar.updateText("Import failed.");
	}

	@Override
	public void operationInitializing() {
		Log.info("Inport Inizializing");
		progressBar.updateProgress(0, "Initializing...");
	}

	@Override
	public void operationUpdate(float elaborated) {
		Log.info("Import elaborated: "+elaborated);
		if (elaborated == 0) progressBar.updateProgress(0, "Initializing...");
		if (elaborated>0 && elaborated<1) {
			Log.trace("progress "+elaborated);
			int elab=new Float(elaborated*100).intValue();
			progressBar.updateProgress(elaborated,elab+"% Importing...");
		}
		if (elaborated == 1) progressBar.updateProgress(1, "Completing...");
		
	}

}
